var PWR_Objects = function(){
    var Response;

    var init = function() {
		$('#form_content input,select').each(function(key,value) {
			var id = $(this).attr('id');
			var obj_type = $('#' + id).attr('type');
            try {
                switch ( obj_type ) {
					case "select":
						var closeonselect = $("#" + id).attr("data-closeonselect");
						if ( closeonselect == "false" ) {
							$("#" + id).select2({ closeOnSelect: false });
						} else {
							$("#" + id).select2(); 
						}
						break;
					default:
						return;
				}
			} catch (err) {
				return;
			}
		});

        return;
    }

    var Load = function(Data) {
		PWR_Objects.Clear();
		
		$.each(Data, function(key,value) {
			/*
			if ( key == "password" )
				return;
			*/
			
			obj_type = $('#' + key).attr('type');
            switch ( obj_type ) {
                case "multi-select":
                    $("#" + key).val(value);
					$("#" + key).multiSelect("refresh");
                    break;
                case "select":
				case "select2":
					$("#" + key).val(value);

					var closeonselect = $("#" + key).attr("data-closeonselect");
					if ( closeonselect == "false" ) {
						// Multi mode
						$("#" + key).select2({ closeOnSelect: false });
					} else {
						// Single mode
						$("#" + key).select2();
					}
					break;
				case "file":
					$("#" + key).siblings(".bootstrap-filestyle").find("input").val(value);
					$("#" + key + "_hid").val(value);
					break;
				case "text":
				case "textarea":
				case "password":
					// console.log(key + " " + value);
					$('#' + key).val(value);
					break;
				case "checkbox":
					if ( value == "on" ) {
						$("#" + key).bootstrapSwitch('state', true);
					} else {
						$("#" + key).bootstrapSwitch('state', false);
					}

					break;
            }
        });
    }

    var Clear = function () {
		$('#form_content input,select,textarea').each(function(key,value) {
			var id = $(this).attr('id');
			var obj_type = $('#' + id).attr('type');
            try {
                switch ( obj_type ) {
                    case "multi-select":
                        $("#" + id).val([]);
						$("#" + id).multiSelect("refresh");
                        break;
					case "select":
						$("#" + id).val(-1);

						var closeonselect = $("#" + id).attr("data-closeonselect");
						if ( closeonselect == "false" ) {
							$("#" + id).select2({ closeOnSelect: false });
						} else {
							$("#" + id).select2();
						}
                        break;
					case "file":
						$("#" + id).filestyle("clear");
						break;
					case "search":
						PWR_Search.Remove(id);
						break;
                    case "text":
                        $("#" + id).val("");
                        break;
                    case "password":
                        $("#" + id).val("");
                        break;
                    case "checkbox":
                        $("#" + id).removeAttr("checked");
                        $("#" + id).change();
                        break;
                    case "textarea":
                        $("#" + id).val("");
                        break;
                }
            } catch (err) {
                return;
            }
        });
	}

	return {
        Response: Response,
        init: function() {
            init();
        },
        Clear: function() {
            Clear();
        },
        Load: function(Data) {
            Load(Data);
        },
    };
	
}();
